]> git.proxmox.com Git - mirror_ubuntu-bionic-kernel.git/blame - scripts/kconfig/Makefile
ceph: quota: add initial infrastructure to support cephfs quotas
[mirror_ubuntu-bionic-kernel.git] / scripts / kconfig / Makefile
CommitLineData
b2441318 1# SPDX-License-Identifier: GPL-2.0
1da177e4
LT
2# ===========================================================================
3# Kernel configuration targets
4# These targets are used from top-level makefile
5
1cba0c30 6PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
281c9dad 7 localmodconfig localyesconfig
1da177e4 8
61bee204
AV
9ifdef KBUILD_KCONFIG
10Kconfig := $(KBUILD_KCONFIG)
11else
838a2e55 12Kconfig := Kconfig
61bee204 13endif
e703f75d 14
0a1f00a1
MM
15ifeq ($(quiet),silent_)
16silent := -s
17endif
18
c2838e6e
YM
19# We need this, in case the user has it in its environment
20unexport CONFIG_
21
1da177e4 22xconfig: $(obj)/qconf
0a1f00a1 23 $< $(silent) $(Kconfig)
1da177e4
LT
24
25gconfig: $(obj)/gconf
0a1f00a1 26 $< $(silent) $(Kconfig)
1da177e4
LT
27
28menuconfig: $(obj)/mconf
0a1f00a1 29 $< $(silent) $(Kconfig)
1da177e4
LT
30
31config: $(obj)/conf
0a1f00a1 32 $< $(silent) --oldaskconfig $(Kconfig)
1da177e4 33
692d97c3 34nconfig: $(obj)/nconf
0a1f00a1 35 $< $(silent) $(Kconfig)
692d97c3 36
1da177e4 37silentoldconfig: $(obj)/conf
9815594a 38 $(Q)mkdir -p include/config include/generated
d3fc425e
NP
39 $(Q)test -e include/generated/autoksyms.h || \
40 touch include/generated/autoksyms.h
0a1f00a1 41 $< $(silent) --$@ $(Kconfig)
1da177e4 42
50bce3e8 43localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
9815594a 44 $(Q)mkdir -p include/config include/generated
22d550ae 45 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
7a996d3a 46 $(Q)if [ -f .config ]; then \
4062f1a4
SR
47 cmp -s .tmp.config .config || \
48 (mv -f .config .config.old.1; \
49 mv -f .tmp.config .config; \
0a1f00a1 50 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
4062f1a4
SR
51 mv -f .config.old.1 .config.old) \
52 else \
53 mv -f .tmp.config .config; \
0a1f00a1 54 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
a7c02602 55 fi
03fa25da
SR
56 $(Q)rm -f .tmp.config
57
1020026f 58# Create new linux.pot file
b70e325c 59# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
46d26319 60update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
0a1f00a1 61 $(Q)$(kecho) " GEN config.pot"
a24a1b8e
PF
62 $(Q)xgettext --default-domain=linux \
63 --add-comments --keyword=_ --keyword=N_ \
64 --from-code=UTF-8 \
65 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
66 --directory=$(srctree) --directory=$(objtree) \
b70e325c
SR
67 --output $(obj)/config.pot
68 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
fa0ad657
PB
69 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
70 $(srctree)/arch/*/um/Kconfig`; \
1020026f 71 do \
0a1f00a1 72 $(kecho) " GEN $$i"; \
4217516e 73 $(obj)/kxgettext $$i \
1020026f
EG
74 >> $(obj)/config.pot; \
75 done )
0a1f00a1 76 $(Q)$(kecho) " GEN linux.pot"
1020026f 77 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
b70e325c 78 --output $(obj)/linux.pot
b70e325c 79 $(Q)rm -f $(obj)/config.pot
3b9fa093 80
1cba0c30
MM
81# These targets map 1:1 to the commandline options of 'conf'
82simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
83 alldefconfig randconfig listnewconfig olddefconfig
84PHONY += $(simple-targets)
1da177e4 85
1cba0c30 86$(simple-targets): $(obj)/conf
0a1f00a1 87 $< $(silent) --$@ $(Kconfig)
1da177e4 88
1cba0c30 89PHONY += oldnoconfig savedefconfig defconfig
1da177e4 90
fb16d891 91# oldnoconfig is an alias of olddefconfig, because people already are dependent
39c3f1ba 92# on its behavior (sets new symbols to their default value but not 'n') with the
fb16d891 93# counter-intuitive name.
1cba0c30 94oldnoconfig: olddefconfig
fb16d891 95
7cf3d73b 96savedefconfig: $(obj)/conf
0a1f00a1 97 $< $(silent) --$@=defconfig $(Kconfig)
7cf3d73b 98
1da177e4
LT
99defconfig: $(obj)/conf
100ifeq ($(KBUILD_DEFCONFIG),)
0a1f00a1 101 $< $(silent) --defconfig $(Kconfig)
42f9d3c6
JB
102else
103ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
0a1f00a1
MM
104 @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
105 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
d2036f30
ME
106else
107 @$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
108 $(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
1da177e4 109endif
42f9d3c6 110endif
1da177e4
LT
111
112%_defconfig: $(obj)/conf
0a1f00a1 113 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
1da177e4 114
63a91033 115configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
3aaefce1 116
63a91033
MY
117%.config: $(obj)/conf
118 $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
119 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
120 +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
3aaefce1
JT
121
122PHONY += kvmconfig
63a91033
MY
123kvmconfig: kvm_guest.config
124 @:
3aaefce1 125
6c668505
LR
126PHONY += xenconfig
127xenconfig: xen.config
128 @:
129
0da1d4a0 130PHONY += tinyconfig
63a91033
MY
131tinyconfig:
132 $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
0da1d4a0 133
1da177e4
LT
134# Help text used by make help
135help:
136 @echo ' config - Update current config utilising a line-oriented program'
fa75a727
GU
137 @echo ' nconfig - Update current config utilising a ncurses menu based'
138 @echo ' program'
1da177e4 139 @echo ' menuconfig - Update current config utilising a menu based program'
092373c2 140 @echo ' xconfig - Update current config utilising a Qt based front-end'
39c3f1ba 141 @echo ' gconfig - Update current config utilising a GTK+ based front-end'
1da177e4 142 @echo ' oldconfig - Update current config utilising a provided .config as base'
03fa25da 143 @echo ' localmodconfig - Update current config disabling modules not loaded'
281c9dad 144 @echo ' localyesconfig - Update current config converting local mods to core'
590a5857 145 @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
0748cb3e 146 @echo ' defconfig - New config with default from ARCH supplied defconfig'
7cf3d73b 147 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
e11f0496 148 @echo ' allnoconfig - New config where all options are answered with no'
0748cb3e
SR
149 @echo ' allyesconfig - New config where all options are accepted with yes'
150 @echo ' allmodconfig - New config selecting modules when possible'
151 @echo ' alldefconfig - New config with all symbols set to default'
152 @echo ' randconfig - New config with random answer to all options'
861b4ea4 153 @echo ' listnewconfig - List new options'
fa75a727
GU
154 @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their'
155 @echo ' default value'
9bcd776d 156 @echo ' kvmconfig - Enable additional options for kvm guest kernel support'
6c668505 157 @echo ' xenconfig - Enable additional options for xen dom0 and guest kernel support'
0da1d4a0 158 @echo ' tinyconfig - Configure the tiniest possible kernel'
1da177e4 159
2982de69
SR
160# lxdialog stuff
161check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
162
e9e40e14 163# Use recursively expanded variables so we do not call gcc unless
2982de69 164# we really need to do so. (Do not call gcc as part of make mrproper)
9ba95682
AL
165HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
166 -DLOCALE
2982de69 167
1da177e4
LT
168# ===========================================================================
169# Shared Makefile for the various kconfig executables:
170# conf: Used for defconfig, oldconfig and related targets
692d97c3 171# nconf: Used for the nconfig target.
172# Utilizes ncurses
6f26e5e4 173# mconf: Used for the menuconfig target
1da177e4
LT
174# Utilizes the lxdialog package
175# qconf: Used for the xconfig target
092373c2 176# Based on Qt which needs to be installed to compile it
1da177e4 177# gconf: Used for the gconfig target
39c3f1ba 178# Based on GTK+ which needs to be installed to compile it
1da177e4
LT
179# object files used by all kconfig flavours
180
2982de69
SR
181lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
182lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
183
1da177e4 184conf-objs := conf.o zconf.tab.o
692d97c3 185mconf-objs := mconf.o zconf.tab.o $(lxdialog)
186nconf-objs := nconf.o zconf.tab.o nconf.gui.o
3b9fa093 187kxgettext-objs := kxgettext.o zconf.tab.o
f1943049 188qconf-cxxobjs := qconf.o
5a6f8d2b
AL
189qconf-objs := zconf.tab.o
190gconf-objs := gconf.o zconf.tab.o
1da177e4 191
022af62d 192hostprogs-y := conf nconf mconf kxgettext qconf gconf
1da177e4 193
5a6f8d2b 194clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
bb3290d9 195clean-files += zconf.tab.c zconf.lex.c gconf.glade.h
1020026f 196clean-files += config.pot linux.pot
1da177e4 197
6e588f6d
SR
198# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
199PHONY += $(obj)/dochecklxdialog
ff85a1a8 200$(addprefix $(obj)/, mconf.o $(lxdialog)): $(obj)/dochecklxdialog
6e588f6d 201$(obj)/dochecklxdialog:
7080e47b 202 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
6e588f6d
SR
203
204always := dochecklxdialog
205
aa1e5ef5
SR
206# Add environment specific flags
207HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
70a6a0cb 208
1da177e4 209# generated files seem to need this to find local include files
2f76b358 210HOSTCFLAGS_zconf.lex.o := -I$(src)
1da177e4
LT
211HOSTCFLAGS_zconf.tab.o := -I$(src)
212
378dbb2c
AL
213LEX_PREFIX_zconf := zconf
214YACC_PREFIX_zconf := zconf
215
5a6f8d2b
AL
216HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
217HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
1da177e4 218
5a6f8d2b 219HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
37193147 220HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
1ea3ad4e 221 -Wno-missing-prototypes
1da177e4 222
7080e47b
AL
223HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
224
544e7e54 225HOSTLOADLIBES_nconf = $(shell \
7285996a
BN
226 pkg-config --libs menuw panelw ncursesw 2>/dev/null \
227 || pkg-config --libs menu panel ncurses 2>/dev/null \
544e7e54 228 || echo "-lmenu -lpanel -lncurses" )
1da177e4
LT
229$(obj)/qconf.o: $(obj)/.tmp_qtcheck
230
022af62d 231ifeq ($(MAKECMDGOALS),xconfig)
b3a5225f 232$(obj)/.tmp_qtcheck: $(src)/Makefile
1da177e4
LT
233-include $(obj)/.tmp_qtcheck
234
092373c2 235# Qt needs some extra effort...
1da177e4 236$(obj)/.tmp_qtcheck:
d1b0dc90 237 @set -e; $(kecho) " CHECK qt"; \
588446a8
TM
238 if pkg-config --exists Qt5Core; then \
239 cflags="-std=c++11 -fPIC `pkg-config --cflags Qt5Core Qt5Gui Qt5Widgets`"; \
240 libs=`pkg-config --libs Qt5Core Qt5Gui Qt5Widgets`; \
241 moc=`pkg-config --variable=host_bins Qt5Core`/moc; \
242 elif pkg-config --exists QtCore; then \
243 cflags=`pkg-config --cflags QtCore QtGui`; \
244 libs=`pkg-config --libs QtCore QtGui`; \
245 moc=`pkg-config --variable=moc_location QtCore`; \
ab919c06 246 else \
d1b0dc90 247 echo >&2 "*"; \
588446a8
TM
248 echo >&2 "* Could not find Qt via pkg-config."; \
249 echo >&2 "* Please install either Qt 4.8 or 5.x. and make sure it's in PKG_CONFIG_PATH"; \
d1b0dc90
TM
250 echo >&2 "*"; \
251 exit 1; \
b3a5225f
RZ
252 fi; \
253 echo "KC_QT_CFLAGS=$$cflags" > $@; \
254 echo "KC_QT_LIBS=$$libs" >> $@; \
255 echo "KC_QT_MOC=$$moc" >> $@
1da177e4
LT
256endif
257
258$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
259
022af62d 260ifeq ($(MAKECMDGOALS),gconfig)
1da177e4
LT
261-include $(obj)/.tmp_gtkcheck
262
39c3f1ba 263# GTK+ needs some extra effort, too...
1da177e4 264$(obj)/.tmp_gtkcheck:
37193147
AB
265 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
266 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
1da177e4
LT
267 touch $@; \
268 else \
5b580fa6
MM
269 echo >&2 "*"; \
270 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
271 echo >&2 "*"; \
1da177e4
LT
272 false; \
273 fi \
274 else \
5b580fa6
MM
275 echo >&2 "*"; \
276 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
277 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
278 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
279 echo >&2 "*"; \
1da177e4
LT
280 false; \
281 fi
282endif
283
bb3290d9 284$(obj)/zconf.tab.o: $(obj)/zconf.lex.c
1da177e4 285
5a6f8d2b 286$(obj)/qconf.o: $(obj)/qconf.moc
1da177e4 287
ebca026a
YS
288quiet_cmd_moc = MOC $@
289 cmd_moc = $(KC_QT_MOC) -i $< -o $@
290
291$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
292 $(call cmd,moc)
1da177e4 293
39c3f1ba 294# Extract gconf menu items for i18n support
46d26319 295$(obj)/gconf.glade.h: $(obj)/gconf.glade
2d80eb0f 296 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
a24a1b8e 297 $(obj)/gconf.glade